
<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator"
import { Member, Source } from "@/model"
import { getMembers, getSources } from "@/store"

@Component({
  template: `
<component :is="{
  data() { return {members: members}},
  template: '<div>' + getTemplateString + '</div>'
  }"/>
`})
export default class MembersTable extends Vue {

  @Prop()
  sourceName?: string

  @Prop()
  templateName?: string

  source?: Source
  sources = getSources()

  setSource() {
    if (this.source != null) return

    for (var source of this.sources) {
      if (source.name == this.sourceName) {
        this.source = source
      }
    }
  }

  get getTemplateString() {
    this.setSource()
    if (this.source == null) return ""
    if (this.templateName == null) return ""
    return this.source.configuration.memberTemplates[this.templateName].templateString
  }

  get members(): Member[] {
    this.setSource()
    if (this.source == null) return []
    let source = this.source
    let members = getMembers(source.name)
    if (this.templateName == null) return members
    let templateName = this.templateName
    members = members.map(member => source.configuration.modify(member, templateName))
    return members.filter(member => source.configuration.filter(member, templateName))
  }
}
</script>